# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/hibernate-search/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirres %{repodir}/resources
%define repodirsrc %{repodir}/src

%define section free

%define reltag GA_CP05
%define hname hibernate-search
%define namedversion %{version}.%{reltag}

Summary:        Hibernate integration with Lucene for indexing and querying data
Name:           hibernate3-search
Version:        3.1.1
Release:        2.4.%{reltag}%{?dist}
Epoch:          0
License:        LGPL
URL:            http://search.hibernate.org/
Group:          Database
Source0:        hibernate-search-%{version}.%{reltag}-src.tar.gz
Source2:		%{hname}-component-info.xml
Source3:        %{hname}-jpp-depmap.xml
Patch0:         activemq.patch

# The following are required to build %{hname}.jar
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 1.5.0
BuildRequires:  maven2
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven-release
BuildRequires:  maven-injection-plugin
#BuildRequires:  maven-surefire
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire,maven2-plugin-surefire-report
#BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-test-ext-plugin
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  jboss-parent
BuildRequires:  jboss-javaee
BuildRequires:  jboss-transaction-1.0.1-api
BuildRequires:  junit >= 3.8.2
BuildRequires:  hibernate3 >= 0:3.3.2
BuildRequires:  hibernate3-commons-annotations >= 0:3.1.0
BuildRequires:  hibernate3-annotations >= 0:3.4.0
BuildRequires:  hibernate3-ejb-persistence-3.0-api >= 0:3.4.0
BuildRequires:  hibernate3-entitymanager >= 0:3.4.0
BuildRequires:  slf4j >= 1.5.6
BuildRequires:  lucene >= 0:2.4.1
BuildRequires:  lucene-contrib >= 0:2.4.1
BuildRequires:  jakarta-commons-logging >= 0:1.0.4
BuildRequires:  hsqldb
BuildRequires:  apache-solr
Requires:  java >= 0:1.5
Requires:  hibernate3 >= 0:3.3.2
Requires:  hibernate3-ejb-persistence-3.0-api >= 0:3.4.0
Requires:  hibernate3-commons-annotations >= 0:3.1.0
Requires:  hibernate3-annotations >= 0:3.4.0
Requires:  hibernate3-entitymanager >= 0:3.4.0
Requires:  jakarta-commons-codec >= 1.3
Requires:  jakarta-commons-io >= 1.3.2

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Hibernate, like all other object/relational mapping tools, 
requires metadata that governs the transformation of data 
from one representation to the other (and vice versa). In 
Hibernate 2.x, mapping metadata is most of the time declared 
in XML text files. Another option is XDoclet, utilizing 
Javadoc source code annotations and a preprocessor at compile 
time.
Hibernate Search brings the power of full text search engines
to the persistence domain model and Hibernate experience,
through transparent configuration (Hibernate Annotations)
and a common API.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package zip
Summary:        Zip distrubution for %{name}
Group:          Development

%description zip
Zip distribution for %{name}.

%prep
%setup -q -n %{hname}
%patch0

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

%build

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

%{_bindir}/mvn-jpp -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE3} \
        -Dmaven.test.failure.ignore=true \
		-Dmaven.test.skip=true \
		-P with-optional-jars,hsqldb \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p target/%{hname}-%{version}.%{reltag}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p target/%{hname}-%{version}.%{reltag}-sources.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{hname}-sources.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|%{name}|%{hname}|g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

## javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%add_to_maven_depmap org.hibernate %{hname} %{namedversion} JPP %{name}

install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
	tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
	sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}

	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/%{hname}.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/%{hname}-sources.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom $RPM_BUILD_ROOT%{repodirlib}/hibernate-search.pom
%endif

# License
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# Dist
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/hibernate3-search-fordev
cp target/hibernate-search*.zip $RPM_BUILD_ROOT%{_javadir}/hibernate3-search-fordev/hibernate-search.zip

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar
#%{_datadir}/%{name}-%{version}
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%files zip
%defattr(0644,root,root,0755)
%{_javadir}/hibernate3-search-fordev/*.zip

%changelog
* Fri Jul 27 2012 Strong Liu <stliu@redhat.com> - 3.1.1-2.4.GA_CP05
- Upgrade to 3.1.1.GA_CP05

* Sat Feb 12 2011 Strong Liu <stliu@redhat.com> - 3.1.1-2.3.GA_CP04
- Upgrade to 3.1.1.GA_CP04
- Update  c-i.xml file

* Mon Jul 26 2010 Strong Liu <stliu@redhat.com> - 3.1.1-2.2.GA_CP03
- Rebuild

* Sun Jul 25 2010 Strong Liu <stliu@redhat.com> - 3.1.1-2.1.GA_CP03
- Upgrade to 3.1.1.GA_CP03

* Thu Jun 03 2010 Strong Liu <stliu@rehdat.com> - 3.1.1-2.0.GA_CP02
- Correct Release Number

* Wed May 26 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.4.GA_CP02
- Correct tag in c-i.xml

* Sun May 23 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.3.GA_CP02
- Add BR maven-injection-plugin
- Update Source

* Fri May 21 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.2.GA_CP02
- Rebuild

* Fri May 21 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.1.GA_CP02
- Update source tarball of 3.1.1.GA_CP02

* Thu May 20 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.0.GA_CP02
- Upgrade to 3.1.1.GA_CP02

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> - 3.1.1-1.9.GA_CP01
- Rebuild

* Fri Jan 29 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.8.GA_CP01
- Add pom to repolib

* Fri Jan 22 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.7.GA_CP01
- Rebuild in brew

* Thu Jan 21 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.6.GA_CP01
- Remove java doc zip file
- Unpatch javadoc section

* Sun Jan 17 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.5.GA_CP01
- Remove old source tarball
* Sat Jan 16 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.4.GA_CP01
- Update release tag to include GA_CP01

* Fri Jan 15 2010 Strong Liu <stliu@redhat.com> - 3.1.1-1.3
- Upgrade Hibernate Search to 3.1.1.GA_CP01

* Wed Jul 29 2009 Permaine Cheung <pcheung@redhat.com> - 3.1.1-1.2
- Fix Requires

* Mon Jul 20 2009 Permaine Cheung <pcheung@redhat.com> - 3.1.1-1.1
- Add BR: maven-surefire-provider-junit, maven-doxia-sitetools
- BR: lucene instead of injecting the jars as we have it built in brew now
- Skip test for now
- Specify buildarch: noarch

* Wed Nov 12 2008 Gail Badner <gbadner@redhat.com> - 3.0.1-1.GA_CP01.ep1
- First build
